/*
  Telescope - Orion EQ2 Mount v1.c
  
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/

// C Libraries
#include "simpletools.h"                   // Include simple tools
#include "propeller.h"
#include "fdserial.h"                       // Full-Duplex Serial

void checkButtons(void)

#define RdirPin     16          // West = High
#define RmotorPin   17
  // DEC Motor - N/S (Up/Down)
#define DdirPin     18
#define DmotorPin   19

#define FDtx        10
#define FDrx        11

#define westPin     4
#define northPin    5
#define eastPin     6
#define southPin    7
#define modePin     ?

fdserial *fd;

int b1, b2, b3, b4;
Project Directory: C:/Users/Orion/Downloads/Telescope-GEN/

SimpleIDE Version 1.1.2
C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/
C:/Users/Orion/Documents/SimpleIDE/ Updated on: 2022-02-13

propeller-elf-gcc.exe -v GCC 4.6.1 (propellergcc_v1_0_0_2408)
propeller-elf-gcc.exe -I . -L . -I C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/Utility/libsimpletools -L C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/Utility/libsimpletools/cmm/ -I C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/TextDevices/libsimpletext -L C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/TextDevices/libsimpletext/cmm/ -I C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/Protocol/libsimplei2c -L C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/Protocol/libsimplei2c/cmm/ -I C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/TextDevices/libfdserial -L C:/Users/Orion/Documents/SimpleIDE/Learn/Simple Libraries/TextDevices/libfdserial/cmm/ -o cmm/Telescope (1).elf -Os -mcmm -m32bit-doubles -fno-exceptions -std=c99 Telescope (1).c -lm -lsimpletools -lsimpletext -lsimplei2c -lfdserial -lm -lsimpletools -lsimpletext -lsimplei2c -lm -lsimpletools -lsimpletext -lm -lsimpletools -lm
Telescope (1).c: In function 'checkButtons':
Telescope (1).c:33:1: error: parameter 'Rspeed' is initialized
Telescope (1).c:33:1: warning: initialization makes pointer from integer without a cast [enabled by default]
Telescope (1).c:33:1: warning: (near initialization for 'Rspeed') [enabled by default]
Telescope (1).c:33:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:33:1: warning: (near initialization for 'Rspeed') [enabled by default]
Telescope (1).c:33:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:33:1: warning: (near initialization for 'Rspeed') [enabled by default]
Telescope (1).c:33:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:33:1: warning: (near initialization for 'Rspeed') [enabled by default]
Telescope (1).c:34:1: error: parameter 'Dspeed' is initialized
Telescope (1).c:34:1: warning: initialization makes pointer from integer without a cast [enabled by default]
Telescope (1).c:34:1: warning: (near initialization for 'Dspeed') [enabled by default]
Telescope (1).c:34:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:34:1: warning: (near initialization for 'Dspeed') [enabled by default]
Telescope (1).c:34:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:34:1: warning: (near initialization for 'Dspeed') [enabled by default]
Telescope (1).c:34:1: warning: excess elements in scalar initializer [enabled by default]
Telescope (1).c:34:1: warning: (near initialization for 'Dspeed') [enabled by default]
Telescope (1).c:44:1: error: expected '=', ',', ';', 'asm' or '__attribute__' before '{' token
Telescope (1).c:117:1: error: expected '=', ',', ';', 'asm' or '__attribute__' before '{' token
Telescope (1).c:13:6: error: old-style parameter declarations in prototyped function definition
Telescope (1).c:157:1: error: expected '{' at end of input
Done. Build Failed!

Click error or warning messages above to debug.
int Rspeed[] = {10, 40, 60, 80};  // <---speed or pulse per seconds.
int Dspeed[] = {8, 40, 60, 80};   // <---speed or pulse per seconds.
int ck;
int i;
char data;
char mode;
char Buffer[8];
char receiveBuffer[8];


int main()
{
  
  low(RmotorPin);
  low(RdirPin);
  low(DmotorPin);
  low(DdirPin);
  
  b1 = input(westPin);
  b2 = input(northPin);
  b3 = input(eastPin);
  b4 = input(southPin);
  
  fd = fdserial_open(FDrx, FDtx, 0, 115200);
  
  while(1)
  {
    i = 0;
    /**
     * Hand Control sends three bytes MD<n1>
     * M - mode value 0 - 3
     * D - Direction (W N E S)
     */
    while(fdserial_rxCount(fd) > 0)
    {
      Buffer[i++] = fdserial_rxChar(fd);  //<--Capture one of the four bytes
      pause(50);
    } 
    
    if (i == 3)                           //<-- valid serial package.
    {
      mode = Buffer[0] - '0';             //<--make numeric value from text
      data = Buffer[1];
      print( "mode:%c, Direction: %c\n",Buffer[0, Buffer[1]);
    }
    else
    {
      mode = 0;
      data = ' ';
    }            
    i = 0;
    
    checkButtons();           //<-- Check Guide camhera(buttons)
    
    switch(data)
    {
      case 'W':
        high(RdirPin);  // move west
        square_wave(RmotorPin,0,Rspeed[mode]);
        break;
        
      case 'N':
        high(DdirPin);  // move north
        square_wave(DmotorPin, 1, Dspeed[mode]);
        break;
        
      case 'E':
        low(RdirPin);   // move east
        square_wave(RmotorPin, 0, Rspeed[mode]);
        break;
        
      case 'S':
        low(DdirPin);   // move south
        square_wave(DmotorPin, 1, Dspeed[mode]);
        break;
    }
    pause(500);
    square_wave_stop();
  }
}
/**
 *check ifone of the local buttons was pushed
 */
void checkButtons()
{
  int i;
  
  i = input(westPin);
  if (i != b1)
  {
    if (i == 0)
    { 
      data = 'W';
    }b1 = i;
  }
  
  i = input(northPin);
  if (i != b2)
  {
    if (i == 0)
    {
      data = 'N';
    }
    b2 = i;
  } 
  i = input(eastPin);
  if (i != b3)
  {
    if (i == 0)
    {
      data = 'E';
    }
    b3 = i;
  }
  
  i = input(southPin);
  if (i != b4)
  {
    if (i == 0)
    {
      data = 'S';
    }
    b4 = i;
  }
}                                                     
        
        